/* (c) 2001 Brad Spengler  */

#include <string.h>
#include <stdio.h>

#include "tracehead.h"

void swapstruct(void *src, void *dst)
{
	struct acls buf;

	memcpy(&buf,dst,sizeof(buf));
	memcpy(dst,src,sizeof(buf));
	memcpy(src,&buf,sizeof(buf));
}

static int newgap(int gap) {
	gap = gap * 10 / 13;
	if (gap < 1)
    		gap = 1;
	if (gap == 9 || gap == 10)
		gap = 11;
	return gap;
}



void tracesort(void)
{
	int gap = counter;
	for (;;) {
		int swapped = 0;
    		int i;
 
   		gap = newgap(gap);
    		for (i = 0; i < counter - gap; i++) {
      		if (strcasecmp(acl[i].filename,acl[i + gap].filename) > 0) {
				swapstruct(&acl[i], &acl[i + gap]);
				swapped = 1;
      		}
		}
		if (gap == 1 && !swapped)
      			break;
	}
}
	
